/*____________________________________________________________________________*\
 *

 Copyright (c) 1997 John Roy. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    (http://www.johnroy.com/pi3/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: Pi3Win.c$
 * $Date: Sun Aug 10 06:40:13 1997$
 *
 Description:

\*____________________________________________________________________________*/
/* $SourceTop:$ */

#ifndef CONFIG_H_
#define CONFIG_H_

#include <windows.h>

/*____________________________________________________________________________*\
 *
 Description:
	Functions and definition of common configuration structures.
\*____________________________________________________________________________*/
typedef void *PTConfig;

extern PTConfig __pConfig;

#if defined(__cplusplus)
#	define EXTERN_C	extern "C"
#endif

#define AD_SERVICE_EXECUTABLE "Pi3Srv32.exe"

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
	Prototypes
\*____________________________________________________________________________*/
EXTERN_C PTConfig AD_loadConfig( const char *pFileName );
EXTERN_C PTConfig AD_createDefaultConfig();
EXTERN_C int AD_uninstall( HINSTANCE hInstance, int iError );
EXTERN_C BOOL AD_cancelSetup( HWND hDlg );
EXTERN_C const char *AD_lookupValue( PTConfig pConfig, const char *pSection,
	const char *pVariable );
EXTERN_C const char *AD_lookupValueEx( PTConfig pConfig, 
	const char *pSection, const char *pVariable, int iIndex );
EXTERN_C int AD_addValue( PTConfig pConfig, const char *pSection,
	const char *pVariable, const char *pNewValue );
EXTERN_C int AD_replaceValue( PTConfig pConfig, const char *pSection,
	const char *pVariable, const char *pNewValue );
EXTERN_C int AD_deleteValue( PTConfig pConfig, const char *pSection,
	const char *pVariable );
EXTERN_C int AD_writeConfig( PTConfig pConfig, const char *pFileName );
EXTERN_C int AD_destroyConfig( PTConfig pConfig );
EXTERN_C void AD_configurationError( const char *pMsg );
EXTERN_C void AD_hourglassInit( void );
EXTERN_C void AD_hourglassDestroy( void );
EXTERN_C void AD_hourglassOn( void );
EXTERN_C void AD_hourglassOff( void );
EXTERN_C void AD_registerURLClass( HINSTANCE hInstance );
EXTERN_C void AD_unregisterURLClass( HINSTANCE hInstance );

#endif /* CONFIG_H_ */
